"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.subscribeConfigure = exports.getConfig = exports.configure = void 0;
var subscribers = [];
var config = readOnly({
  lang: 'en'
});
function readOnly(newConfig) {
  return new Proxy(newConfig, {
    set: function set() {
      throw new Error('Do not edit the config directly');
    }
  });
}
var configure = exports.configure = function configure(newConfig) {
  config = readOnly(Object.assign({}, config, newConfig));
  subscribers.forEach(function (sub) {
    sub(config);
  });
};
var subscribeConfigure = exports.subscribeConfigure = function subscribeConfigure(sub) {
  subscribers.push(sub);
  sub(config);
  return function () {
    subscribers = subscribers.filter(function (item) {
      return item !== sub;
    });
  };
};
var getConfig = exports.getConfig = function getConfig() {
  return config;
};
// #sourceMappingURL=configure.js.map
// #sourceMappingURL=configure.js.map