"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Primary = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _react = _interopRequireDefault(require("react"));
var _index = require("../../../index");
var _jsxRuntime = require("react/jsx-runtime");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function MyControl(props) {
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
    children: ["Hello, ", props.username, "!"]
  });
}
MyControl.getDefaultValue = function () {
  return null;
};

// step 1
(0, _index.registerDialogControl)('my-control', MyControl);

// step 2

// step 3
function MyDialog(props) {
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_index.DFDialog, (0, _objectSpread2.default)({}, props));
}
function Demo() {
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
    style: {
      whiteSpace: 'pre'
    },
    children: ["The library provides limited amount of basic control that you may use out of the box.", /*#__PURE__*/(0, _jsxRuntime.jsx)("br", {}), "But sometimes it is required to add some project-specific controls, in that case", /*#__PURE__*/(0, _jsxRuntime.jsx)("br", {}), "you need to implement required control and then correctly register it.", /*#__PURE__*/(0, _jsxRuntime.jsx)("br", {}), /*#__PURE__*/(0, _jsxRuntime.jsx)("br", {}), "It is impossible to modify the declaration of DFDialogField type, but it is possible to", /*#__PURE__*/(0, _jsxRuntime.jsx)("br", {}), "implement your own dialog which will wrap DFDialog and have extended set of allowed controls.", /*#__PURE__*/(0, _jsxRuntime.jsx)("br", {}), "This example demonstrates how to create your own dialog with additional fields.", /*#__PURE__*/(0, _jsxRuntime.jsx)("br", {}), /*#__PURE__*/(0, _jsxRuntime.jsx)("br", {}), "To register a custom control you need to complete 3 steps:", /*#__PURE__*/(0, _jsxRuntime.jsxs)("ol", {
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("li", {
        children: "Register a custom control with a unique type"
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)("li", {
        children: "Declare DialogField type that extends DFDialogField"
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)("li", {
        children: "Implement your own Dialog which will use DialogField type from step 2"
      })]
    }), "Please see its internals:\xA0", /*#__PURE__*/(0, _jsxRuntime.jsx)("a", {
      href: 'https://github.com/gravity-ui/dialog-fields/blob/main/src/stories/dialog/register/RegisterControls.stories.tsx',
      children: "the code"
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)("br", {}), /*#__PURE__*/(0, _jsxRuntime.jsx)("br", {}), "Also it might be useful to know:", /*#__PURE__*/(0, _jsxRuntime.jsx)("br", {}), "- registerDialogControl accepts only Components which Props extends interface:", /*#__PURE__*/(0, _jsxRuntime.jsx)("code", {
      children: '\n interface ControlProps<V> {' + '\n    value: V;' + '\n    onChange: (value: V, opts?: any) => void;' + '\n    error?: string;' + '\n }\n'
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)("br", {}), "- and static methods/fields of the component should satisfy to:", /*#__PURE__*/(0, _jsxRuntime.jsx)("code", {
      children: '\n interface ControlStaticApi<V> {' + '\n    isEmpty?: (value: V) => boolean;' + '\n    getDefaultValue: () => V;' + '\n    hasErrorRenderer?: boolean;' + '\n    validate?: ValidatorType<V, any>;' + '\n    format?: (value: V, name: string) => any;' + '\n }\n\n'
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)("h3", {
      children: "Usage:"
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(MyDialog, {
      visible: true,
      modal: false,
      fields: [{
        name: 'username',
        type: 'my-control',
        caption: 'My control',
        extras: {
          username: 'world'
        }
      }],
      onAdd: function onAdd() {
        return Promise.resolve();
      }
    })]
  });
}
var _default = exports.default = {
  title: 'Tutorials/Custom control registration',
  component: Demo
};
var Template = function Template() {
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(Demo, {});
};
var Primary = exports.Primary = Template.bind({});
Primary.args = {};
// #sourceMappingURL=RegisterControls.stories.js.map
// #sourceMappingURL=RegisterControls.stories.js.map