"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.WithMaxVisibleCount = exports.WithItemRenderer = exports.Frozen = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _isNativeReflectConstruct2 = _interopRequireDefault(require("@babel/runtime/helpers/isNativeReflectConstruct"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _react = _interopRequireDefault(require("react"));
var _uikit = require("@gravity-ui/uikit");
var _index = require("../index");
var _jsxRuntime = require("react/jsx-runtime");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _callSuper(t, o, e) {
  return o = (0, _getPrototypeOf2.default)(o), (0, _possibleConstructorReturn2.default)(t, (0, _isNativeReflectConstruct2.default)() ? Reflect.construct(o, e || [], (0, _getPrototypeOf2.default)(t).constructor) : o.apply(t, e));
}
function genEditableListData() {
  return ['Red', 'white', 'black', 'green', 'Orange', 'magenta', 'cyan', 'Lime', 'purple', 'red white black green orange magenta cyan lime purple 1', 'red white black green orange magenta cyan lime purple 2'].map(function (i, index) {
    return {
      title: i,
      frozen: index % 3 === 0
    };
  });
}
var EditableListDemoItem = /*#__PURE__*/function (_React$Component) {
  function EditableListDemoItem() {
    var _this;
    (0, _classCallCheck2.default)(this, EditableListDemoItem);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _callSuper(this, EditableListDemoItem, [].concat(args));
    _this.state = {
      data: _this.props.value
    };
    _this.onChange = function (data) {
      _this.setState({
        data: data
      });
    };
    return _this;
  }
  (0, _inherits2.default)(EditableListDemoItem, _React$Component);
  return (0, _createClass2.default)(EditableListDemoItem, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_react.default.Fragment, {
        children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
          style: {
            maxWidth: 300
          },
          children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_index.EditableList, (0, _objectSpread2.default)((0, _objectSpread2.default)({}, this.props), {}, {
            value: this.state.data,
            onChange: this.onChange
          }))
        }), /*#__PURE__*/(0, _jsxRuntime.jsxs)(_uikit.Text, {
          className: 'value-as-json',
          style: {
            whiteSpace: 'pre-wrap'
          },
          children: ['\n\n[\n', this.state.data.reduce(function (acc, item) {
            return acc + JSON.stringify(item) + ',\n';
          }, '')]
        })]
      });
    }
  }]);
}(_react.default.Component);
var _default = exports.default = {
  title: 'Components/EditableList',
  component: EditableListDemoItem,
  argTypes: {}
};
var Frozen = exports.Frozen = {
  render: function render(args) {
    return /*#__PURE__*/(0, _jsxRuntime.jsx)(EditableListDemoItem, (0, _objectSpread2.default)({}, args));
  },
  args: {
    frozen: true,
    value: genEditableListData()
  }
};
var WithMaxVisibleCount = exports.WithMaxVisibleCount = (0, _objectSpread2.default)((0, _objectSpread2.default)({}, Frozen), {}, {
  args: {
    maxVisibleCount: 3,
    value: genEditableListData()
  }
});
var WithItemRenderer = exports.WithItemRenderer = (0, _objectSpread2.default)((0, _objectSpread2.default)({}, Frozen), {}, {
  args: {
    value: genEditableListData(),
    itemRenderer: function itemRenderer(item) {
      var title = item.title,
        removed = item.removed;
      return /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
        style: {
          textDecoration: removed ? 'line-through' : 'underline'
        },
        children: title
      });
    }
  }
});
// #sourceMappingURL=EditableList.stories.js.map
// #sourceMappingURL=EditableList.stories.js.map