import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _isNativeReflectConstruct from "@babel/runtime/helpers/isNativeReflectConstruct";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
import React, { Component, Fragment } from 'react';
import { Button } from '@gravity-ui/uikit';
import { DFDialog } from '../../index';
import { useSize } from '../../../stories/SizeContext';
import { ConfirmedFormValues } from '../../../stories/ConfirmedFormValues';
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
var DialogWithSelectStories = /*#__PURE__*/function (_Component) {
  function DialogWithSelectStories() {
    var _this;
    _classCallCheck(this, DialogWithSelectStories);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _callSuper(this, DialogWithSelectStories, [].concat(args));
    _this.state = {
      dialogVisible: true,
      initialState: {},
      formData: {},
      showModal: false
    };
    _this.onToggleModal = function () {
      _this.setState({
        showModal: !_this.state.showModal
      });
    };
    _this.onAdd = function (form) {
      _this.setState({
        formData: form.getState().values
      });
      return Promise.resolve();
    };
    return _this;
  }
  _inherits(DialogWithSelectStories, _Component);
  return _createClass(DialogWithSelectStories, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$state = this.state,
        formData = _this$state.formData,
        showModal = _this$state.showModal;
      return /*#__PURE__*/_jsxs(Fragment, {
        children: [/*#__PURE__*/_jsx(Button, {
          onClick: this.onToggleModal,
          children: "Show modal"
        }), /*#__PURE__*/_jsx(ConfirmedFormValues, {
          data: formData
        }), /*#__PURE__*/_jsx(DialogDemo, {
          onAdd: this.onAdd,
          modal: false
        }), showModal && /*#__PURE__*/_jsx(DialogDemo, {
          modal: true,
          onAdd: this.onAdd,
          onClose: function onClose() {
            return _this2.onToggleModal();
          }
        })]
      });
    }
  }]);
}(Component);
function makeField(type, extras) {
  var res = {
    type: type,
    name: type,
    required: true,
    caption: type,
    tooltip: "Help for ".concat(type)
  };
  if (extras) {
    Object.assign(res, {
      extras: extras
    });
  }
  return res;
}
function option(v) {
  return {
    value: v,
    label: v
  };
}
function DialogDemo(_ref) {
  var modal = _ref.modal,
    onAdd = _ref.onAdd,
    onClose = _ref.onClose;
  return /*#__PURE__*/_jsx(DFDialog, _objectSpread(_objectSpread({
    modal: modal,
    headerProps: {
      title: 'Base controls'
    },
    onClose: onClose !== null && onClose !== void 0 ? onClose : function () {},
    visible: true
  }, useSize()), {}, {
    onAdd: onAdd,
    initialValues: {
      plain: 'Some text for "plain" control',
      radio: 'first',
      'multi-text': [{
        name: 'apple'
      }, {
        name: 'orange'
      }, {
        name: 'pear'
      }],
      'editable-list': [{
        title: 'red',
        frozen: true
      }, {
        title: 'green'
      }, {
        title: 'blue'
      }],
      'multi-editable-lists': [{
        title: 'Fruits',
        data: [{
          title: 'apple'
        }, {
          title: 'orange',
          frozen: true
        }, {
          title: 'pear'
        }]
      }, {
        title: 'Colors',
        data: [{
          title: 'red'
        }, {
          title: 'green'
        }, {
          title: 'blue',
          frozen: true
        }]
      }]
    },
    pristineSubmittable: true,
    fields: [makeField('block', {
      children: /*#__PURE__*/_jsxs("div", {
        children: [/*#__PURE__*/_jsx("div", {
          style: {
            color: 'gray',
            paddingBottom: '20px'
          },
          children: "This page demonstrates base set of registered field types."
        }), /*#__PURE__*/_jsx("b", {
          children: "block"
        }), " is used for custom content"]
      })
    }), makeField('text', {
      autoFocus: true
    }), makeField('multi-text'), makeField('checkbox', {
      children: 'checkbox'
    }), makeField('tumbler', {
      labelLeft: 'Left label',
      labelRight: 'Right label'
    }), makeField('radio', {
      options: [option('first'), option('second')]
    }), makeField('editable-list'), makeField('multi-editable-lists'), makeField('textarea'), makeField('plain'), {
      name: 'plainPlaceholder',
      type: 'plain',
      caption: 'Plain with placeholder',
      extras: {
        placeholder: 'Plain text placeholder...'
      }
    }, makeField('select', {
      width: 'max',
      filterable: true,
      hasClear: true,
      options: ['red', 'green', 'blue'].map(function (i) {
        return {
          value: i,
          content: i
        };
      })
    })]
  }));
}
export default {
  title: 'Demo/00. Base controls',
  component: DialogWithSelectStories
};
var Template = function Template(args) {
  return /*#__PURE__*/_jsx(DialogWithSelectStories, _objectSpread({}, args));
};
export var Primary = Template.bind({});
Primary.args = {};
// #sourceMappingURL=00_Base_controls.stories.js.map