import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _isNativeReflectConstruct from "@babel/runtime/helpers/isNativeReflectConstruct";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
import React, { Component, Fragment } from 'react';
import { Button } from '@gravity-ui/uikit';
import { DFDialog } from '../../index';
import { useSize } from '../../../stories/SizeContext';
import { ConfirmedFormValues } from '../../../stories/ConfirmedFormValues';
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
var DialogWithSelectStories = /*#__PURE__*/function (_Component) {
  function DialogWithSelectStories() {
    var _this;
    _classCallCheck(this, DialogWithSelectStories);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _callSuper(this, DialogWithSelectStories, [].concat(args));
    _this.state = {
      dialogVisible: true,
      initialState: {},
      formData: {},
      showModal: false
    };
    _this.onToggleModal = function () {
      _this.setState({
        showModal: !_this.state.showModal
      });
    };
    _this.onAdd = function (form) {
      _this.setState({
        formData: form.getState().values
      });
      return Promise.resolve();
    };
    return _this;
  }
  _inherits(DialogWithSelectStories, _Component);
  return _createClass(DialogWithSelectStories, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var verticalTabs = this.props.verticalTabs;
      var _this$state = this.state,
        initialState = _this$state.initialState,
        formData = _this$state.formData,
        showModal = _this$state.showModal;
      return /*#__PURE__*/_jsxs(Fragment, {
        children: [/*#__PURE__*/_jsx(Button, {
          onClick: this.onToggleModal,
          children: "Show modal"
        }), /*#__PURE__*/_jsx(ConfirmedFormValues, {
          data: formData
        }), /*#__PURE__*/_jsx(DialogDemo, {
          initialValues: initialState,
          onAdd: this.onAdd,
          modal: false,
          verticalTabs: verticalTabs
        }), showModal && /*#__PURE__*/_jsx(DialogDemo, {
          initialValues: formData,
          modal: true,
          onAdd: this.onAdd,
          onClose: function onClose() {
            return _this2.onToggleModal();
          },
          verticalTabs: verticalTabs
        })]
      });
    }
  }]);
}(Component);
function DialogDemo(_ref) {
  var modal = _ref.modal,
    onAdd = _ref.onAdd,
    initialValues = _ref.initialValues,
    onClose = _ref.onClose,
    verticalTabs = _ref.verticalTabs;
  var tabType = verticalTabs ? 'tab-vertical' : 'tab';
  return /*#__PURE__*/_jsx(DFDialog, _objectSpread(_objectSpread({
    modal: modal,
    headerProps: {
      title: 'Several tabs'
    }
  }, useSize()), {}, {
    onClose: onClose !== null && onClose !== void 0 ? onClose : function () {},
    visible: true,
    onAdd: onAdd,
    initialValues: initialValues,
    pristineSubmittable: true,
    fields: [{
      name: 'general',
      title: 'General',
      type: tabType,
      fields: [{
        type: 'block',
        name: 'block',
        extras: {
          children: /*#__PURE__*/_jsx("div", {
            style: {
              color: 'gray'
            },
            children: "There is ability to create forms with several tabs. By default tabs are horizontally oriented, but it is possible to make them vertically oriented."
          })
        }
      }, {
        name: 'firstName',
        type: 'text',
        caption: 'First name'
      }, {
        name: 'lastName',
        type: 'text',
        caption: 'Last name'
      }]
    }, {
      name: 'contacts',
      title: 'Contacts',
      type: tabType,
      fields: [{
        name: 'email',
        type: 'text',
        caption: 'Email'
      }, {
        name: 'phone',
        type: 'text',
        caption: 'Phone'
      }]
    }]
  }));
}
export default {
  title: 'Demo/02. Several tab',
  component: DialogWithSelectStories
};
var Template = function Template(args) {
  return /*#__PURE__*/_jsx(DialogWithSelectStories, _objectSpread({}, args));
};
export var HorizontalTabs = Template.bind({});
HorizontalTabs.args = {};
export var VerticalTabs = Template.bind({});
VerticalTabs.args = {
  verticalTabs: true
};
// #sourceMappingURL=02_Several_tabs.stories.js.map