import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _isNativeReflectConstruct from "@babel/runtime/helpers/isNativeReflectConstruct";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
import React, { Component, Fragment } from 'react';
import { Button } from '@gravity-ui/uikit';
import { DFDialog } from '../../index';
import { useSize } from '../../../stories/SizeContext';
import { ConfirmedFormValues } from '../../../stories/ConfirmedFormValues';
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
var DialogWithSelectStories = /*#__PURE__*/function (_Component) {
  function DialogWithSelectStories() {
    var _this;
    _classCallCheck(this, DialogWithSelectStories);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _callSuper(this, DialogWithSelectStories, [].concat(args));
    _this.state = {
      dialogVisible: true,
      initialState: {},
      formData: {},
      showModal: false
    };
    _this.onToggleModal = function () {
      _this.setState({
        showModal: !_this.state.showModal
      });
    };
    _this.onAdd = function (form) {
      _this.setState({
        formData: form.getState().values
      });
      return Promise.resolve();
    };
    return _this;
  }
  _inherits(DialogWithSelectStories, _Component);
  return _createClass(DialogWithSelectStories, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$state = this.state,
        initialState = _this$state.initialState,
        formData = _this$state.formData,
        showModal = _this$state.showModal;
      return /*#__PURE__*/_jsxs(Fragment, {
        children: [/*#__PURE__*/_jsx(Button, {
          onClick: this.onToggleModal,
          children: "Show modal"
        }), /*#__PURE__*/_jsx(ConfirmedFormValues, {
          data: formData
        }), /*#__PURE__*/_jsx(DialogDemo, {
          initialValues: initialState,
          onAdd: this.onAdd,
          modal: false
        }), showModal && /*#__PURE__*/_jsx(DialogDemo, {
          initialValues: formData,
          modal: true,
          onAdd: this.onAdd,
          onClose: function onClose() {
            return _this2.onToggleModal();
          }
        })]
      });
    }
  }]);
}(Component);
function DialogDemo(_ref) {
  var modal = _ref.modal,
    onAdd = _ref.onAdd,
    initialValues = _ref.initialValues,
    onClose = _ref.onClose;
  return /*#__PURE__*/_jsx(DFDialog, _objectSpread(_objectSpread({
    modal: modal,
    headerProps: {
      title: 'Linked fields by value'
    }
  }, useSize()), {}, {
    onClose: onClose !== null && onClose !== void 0 ? onClose : function () {},
    visible: true,
    onAdd: onAdd,
    initialValues: initialValues,
    pristineSubmittable: true,
    fields: [{
      type: 'block',
      name: 'block',
      extras: {
        children: /*#__PURE__*/_jsxs("div", {
          style: {
            color: 'gray'
          },
          children: ["It is possible to provide additional properties for controls by using ", /*#__PURE__*/_jsx("b", {
            children: "extras"
          }), ". Also you can make fields depending to each other by values by using this property."]
        })
      }
    }, {
      name: 'type',
      type: 'select',
      caption: 'Type',
      extras: {
        width: 'max',
        placeholder: 'Type',
        options: [{
          value: 'color',
          content: 'Color'
        }, {
          value: 'fruit',
          content: 'Fruit'
        }],
        hasClear: true
      }
    }, {
      name: 'choice',
      type: 'select',
      caption: 'Choice',
      extras: function extras(_ref2, _ref3) {
        var _ref2$type = _ref2.type,
          type = _ref2$type === void 0 ? [] : _ref2$type;
        var input = _ref3.input;
        var _type = _slicedToArray(type, 1),
          selectedType = _type[0];
        var values = selectedType === 'color' ? ['red', 'greed', 'blue'] : ['apple', 'orange', 'pear'];
        var value = input.value,
          onChange = input.onChange;
        if (value !== null && value !== void 0 && value[0] && -1 === values.indexOf(value[0])) {
          setTimeout(function () {
            onChange([]);
          }, 200);
        }
        return {
          width: 'max',
          disabled: !selectedType,
          placeholder: !selectedType ? 'You have to pick a "Type" to unlock the field.' : "Choose your ".concat(selectedType, "..."),
          options: values.map(function (i) {
            return {
              value: i,
              content: i
            };
          })
        };
      }
    }]
  }));
}
export default {
  title: 'Demo/05. Extras and linked fields',
  component: DialogWithSelectStories
};
var Template = function Template(args) {
  return /*#__PURE__*/_jsx(DialogWithSelectStories, _objectSpread({}, args));
};
export var Primary = Template.bind({});
Primary.args = {};
// #sourceMappingURL=05_Extras_and_linked_fields.stories.js.map