import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _isNativeReflectConstruct from "@babel/runtime/helpers/isNativeReflectConstruct";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
import React, { Component, Fragment } from 'react';
import { Button } from '@gravity-ui/uikit';
import { DFDialog } from '../../index';
import { useSize } from '../../../stories/SizeContext';
import { ConfirmedFormValues } from '../../../stories/ConfirmedFormValues';
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
var DialogWithSelectStories = /*#__PURE__*/function (_Component) {
  function DialogWithSelectStories() {
    var _this;
    _classCallCheck(this, DialogWithSelectStories);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _callSuper(this, DialogWithSelectStories, [].concat(args));
    _this.state = {
      dialogVisible: true,
      initialState: {},
      formData: undefined,
      showModal: false
    };
    _this.onToggleModal = function () {
      _this.setState({
        showModal: !_this.state.showModal
      });
    };
    _this.onAdd = function (form) {
      _this.setState({
        formData: form.getState().values
      });
      return Promise.resolve();
    };
    return _this;
  }
  _inherits(DialogWithSelectStories, _Component);
  return _createClass(DialogWithSelectStories, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$state = this.state,
        initialState = _this$state.initialState,
        formData = _this$state.formData,
        showModal = _this$state.showModal;
      return /*#__PURE__*/_jsxs(Fragment, {
        children: [/*#__PURE__*/_jsx(Button, {
          onClick: this.onToggleModal,
          children: "Show modal"
        }), /*#__PURE__*/_jsx(ConfirmedFormValues, {
          data: formData
        }), /*#__PURE__*/_jsx(DialogDemo, {
          initialValues: formData || initialState,
          onAdd: this.onAdd,
          modal: false
        }), showModal && /*#__PURE__*/_jsx(DialogDemo, {
          initialValues: formData,
          modal: true,
          onAdd: this.onAdd,
          onClose: function onClose() {
            return _this2.onToggleModal();
          }
        })]
      });
    }
  }]);
}(Component);
function DialogDemo(_ref) {
  var modal = _ref.modal,
    onAdd = _ref.onAdd,
    initialValues = _ref.initialValues,
    onClose = _ref.onClose;
  return /*#__PURE__*/_jsx(DFDialog, _objectSpread(_objectSpread({
    modal: modal,
    headerProps: {
      title: 'Virtualized tabs'
    }
  }, useSize()), {}, {
    onClose: onClose !== null && onClose !== void 0 ? onClose : function () {},
    visible: true,
    onAdd: onAdd,
    initialValues: initialValues,
    pristineSubmittable: true,
    fields: [{
      name: 'general',
      title: 'General',
      type: 'tab-vertical',
      fields: [{
        type: 'block',
        name: 'block',
        extras: {
          children: /*#__PURE__*/_jsx("div", {
            style: {
              color: 'gray'
            },
            children: "In rare cases it might be required to handle hundreds of tabs and it will affect the performance. It is reasonable to use virtualized tabs for such cases. But when virtualization is enabled then only fields of active tab are mounted and as result field-level validation will work correctly only for current tab. In case of virtualization it is recommended to use form-level validation."
          })
        }
      }, {
        name: 'firstName',
        type: 'text',
        caption: 'First name'
      }, {
        name: 'lastName',
        type: 'text',
        caption: 'Last name'
      }]
    }, {
      name: 'cities',
      type: 'tab-vertical',
      title: 'City',
      multiple: true,
      getTitle: function getTitle(d) {
        var city = d.city,
          id = d.id;
        return city ? city : "City ".concat(id);
      },
      renderControls: function renderControls(_data, onCreate, onRemove) {
        return /*#__PURE__*/_jsxs("div", {
          children: [/*#__PURE__*/_jsx(Button, {
            onClick: function onClick() {
              return onCreate();
            },
            children: "Clone"
          }), ' ', onRemove && /*#__PURE__*/_jsx(Button, {
            onClick: onRemove,
            children: "Remove"
          })]
        });
      },
      fields: [{
        name: 'country',
        type: 'text',
        caption: 'Country'
      }, {
        name: 'city',
        type: 'text',
        caption: 'City/Town'
      }, {
        name: 'notice',
        type: 'textarea',
        caption: 'Notice'
      }]
    }],
    virtualized: true
  }));
}
export default {
  title: 'Demo/08. Virtualized tabs',
  component: DialogWithSelectStories
};
var Template = function Template(args) {
  return /*#__PURE__*/_jsx(DialogWithSelectStories, _objectSpread({}, args));
};
export var Primary = Template.bind({});
Primary.args = {};
// #sourceMappingURL=08_Virtualized_tabs.stories.js.map