import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _isNativeReflectConstruct from "@babel/runtime/helpers/isNativeReflectConstruct";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
import React from 'react';
import { dfCN } from '../../helpers/cn';
import { RepeatIcon, CloseIcon } from '../Icon/Icon';
import './EditableList.css';
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
var block = dfCN('editable-list');
EditableListItem.defaultProps = {
  itemRenderer: function itemRenderer(item) {
    return item.title;
  }
};
function EditableListItem(_ref) {
  var index = _ref.index,
    className = _ref.className,
    item = _ref.item,
    frozen = _ref.frozen,
    toggleRemove = _ref.toggleRemove,
    itemRenderer = _ref.itemRenderer;
  var onClick = React.useCallback(function () {
    toggleRemove(item, index);
  }, [item, toggleRemove, index]);
  var icon = item.removed ? /*#__PURE__*/_jsx(RepeatIcon, {}) : /*#__PURE__*/_jsx(CloseIcon, {});
  var hasActions = !frozen && !item.frozen;
  return /*#__PURE__*/_jsxs("span", {
    className: block('item', className),
    children: [/*#__PURE__*/_jsx("span", {
      className: block('item-content', {
        removed: item.removed
      }),
      title: item.title,
      children: itemRenderer(item)
    }), hasActions && /*#__PURE__*/_jsx("span", {
      className: block('item-action'),
      onClick: onClick,
      children: icon
    })]
  });
}
export var EditableList = /*#__PURE__*/function (_React$Component) {
  function EditableList() {
    var _this;
    _classCallCheck(this, EditableList);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _callSuper(this, EditableList, [].concat(args));
    _this.state = {
      showAll: false
    };
    _this.renderItem = function (item, index) {
      var _this$props = _this.props,
        itemClassName = _this$props.itemClassName,
        itemRenderer = _this$props.itemRenderer,
        frozen = _this$props.frozen;
      return /*#__PURE__*/_jsx(EditableListItem, {
        className: itemClassName,
        index: index,
        item: item,
        frozen: frozen,
        toggleRemove: _this.toggleRemove,
        itemRenderer: itemRenderer
      }, index);
    };
    _this.toggleRemove = function (item, index) {
      var _this$props2 = _this.props,
        value = _this$props2.value,
        onChange = _this$props2.onChange;
      var res = _toConsumableArray(value);
      res[index] = _objectSpread(_objectSpread({}, item), {}, {
        removed: !item.removed
      });
      onChange(res);
    };
    _this.onShowAll = function () {
      _this.setState({
        showAll: !_this.state.showAll
      });
    };
    return _this;
  }
  _inherits(EditableList, _React$Component);
  return _createClass(EditableList, [{
    key: "renderShowAll",
    value: function renderShowAll() {
      var showAll = this.state.showAll;
      var text = showAll ? 'Hide' : 'Show all';
      return /*#__PURE__*/_jsx("span", {
        className: block('show-all'),
        onClick: this.onShowAll,
        children: text
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
        className = _this$props3.className,
        value = _this$props3.value,
        maxVisibleCount = _this$props3.maxVisibleCount;
      var showAll = this.state.showAll;
      var itemsToRender = !showAll && maxVisibleCount ? value.slice(0, maxVisibleCount) : value;
      var showAllVisible = showAll || itemsToRender.length !== value.length;
      return /*#__PURE__*/_jsxs("div", {
        className: block(null, className),
        children: [itemsToRender.map(this.renderItem), showAllVisible && this.renderShowAll()]
      });
    }
  }], [{
    key: "getDefaultValue",
    value: function getDefaultValue() {
      return [];
    }
  }, {
    key: "isEmpty",
    value: function isEmpty() {
      return false;
    }
  }]);
}(React.Component);
EditableList.defaultProps = {
  value: []
};
// #sourceMappingURL=EditableList.js.map